import visa
from datetime import datetime, date, time

starttime = datetime.now()

ResourceManager = visa.ResourceManager()
Resources = ResourceManager.list_resources()

FoundSource = False

for Resource in Resources:
    Instrument = ResourceManager.open_resource(Resource)
    try:
        InstrumentId = Instrument.query("*IDN?")
    except visa.VisaIOError as Error:
        print("query", Resource, Error.description)
    else:
        if "66309D" in InstrumentId:
            FoundSource = True
            SourceInstrument = Instrument
            print("Found Source", Resource, InstrumentId[:-1])
            break
        else:
            Instrument.close()

if FoundSource:
    bytes = bytearray(256*1024)
    for i in range(len(bytes)//4):
        fourbytes = SourceInstrument.query("DIAG:PEEK? #H{0:X}".format(i))
        bytes[i*4] = int(fourbytes[8:10],16)
        bytes[i*4 + 1] = int(fourbytes[6:8],16)
        bytes[i*4 + 2] = int(fourbytes[4:6],16)
        bytes[i*4 + 3] = int(fourbytes[2:4],16)
    with open("firmware.bin", "wb") as f:
        f.write(bytes)
    SourceInstrument.close()

endtime = datetime.now()
print("Elasped time:", endtime - starttime)
